//  File:  Except.java - Demonstrate Exceptions and Exception Handling

public class Except {
    
    Except() {
        System.out.println(LS + "Divide by zero...");
        try {
            int nNum = 4;
            for (int i = 4; i >= 0; i--)
                System.out.println("  " + nNum + " / " + i + "  =  " + (nNum / i));
        } catch (ArithmeticException e) {
            System.out.println("Exception thrown: " + e);
        }

        System.out.println(LS + "Array index out of bounds...");
        int[] nArray = new int[5];
        try {
            for (int i = 0; i <= 5; i++)
                nArray[i] = i;
        } catch (ArrayIndexOutOfBoundsException e) {
            System.out.println("Exception thrown: " + e);
        }

        System.out.println(LS + "Demonstrate an exception in sub-method 1");
        try {
            aMethod1();
        } catch (ClassCastException e) {
            System.out.println("Exception thrown: " + e);
        }

        System.out.println(LS + "Demonstrate an exception in sub-method 2");
        try {
            aMethod2();
        } catch (Error e) {
            System.out.println("Error caught: " + e);
        }
    }

    private void aMethod1() {
        System.out.println("  Inside aMethod1...");
        String s = (String) (new Object());
    }

    private void aMethod2() {
        int  n = 1000000;
        while (true) {
            System.out.println("  Allocating " + n + " doubles");
            double dArray[] = new double[n];
            n += n;
        }
    }

    public static void main(String[] args) {
        System.out.println("Demonstrate Exceptions and Exception Handling");
        new Except();
        System.out.println(LS + "That's all, folks!" + LS);
    }

    public static final String LS = System.getProperty("line.separator");

}

/* ===== Execution Output =====

Demonstrate Exceptions and Exception Handling

Divide by zero...
  4 / 4  =  1
  4 / 3  =  1
  4 / 2  =  2
  4 / 1  =  4
Exception thrown: java.lang.ArithmeticException: / by zero

Array index out of bounds...
Exception thrown: java.lang.ArrayIndexOutOfBoundsException: 5

Demonstrate an exception in sub-method 1
  Inside aMethod1...
Exception thrown: java.lang.ClassCastException

Demonstrate an exception in sub-method 2
  Allocating 1000000 doubles
  Allocating 2000000 doubles
  Allocating 4000000 doubles
  Allocating 8000000 doubles
Error caught: java.lang.OutOfMemoryError

That's all, folks!

===== End of Output ===== */
